<?php
/**
 * API-call related functions
 *
 * @author Remdev
 * @license MIT License
 */
class Api {
    
    protected $api_url = 'http://api.remdev.net/';
    protected $api_key;
    
    
    public function __construct($api_key = '') {
        $this->api_key = $api_key;
    }
    
    protected function jsonQuery($url) {
        $opts = array('http' =>
            array(
                'method'  => 'GET',
                'timeout' => 10 
            )
        );
        
        $context  = stream_context_create($opts);
        $feed = file_get_contents($url, false, $context);
        
        return json_decode($feed,true);
    }
    
    
    public function getBalance() {
        return $this->jsonQuery($this->api_url."?key={$this->api_key}&action=getBalance");
    }

    public function transferMoney($toUser,$money) {
        return $this->jsonQuery($this->api_url."?key={$this->api_key}&action=transferMoney&toUser={$toUser}&money={$money}");

    }
    
}