<?php

class core{
    var $header         = 'Без названия';
    var $security_type  = array(1 => 'Вход в аккаунт', 2 => 'Неудачная попытка авторизации', 3 => '');
    var $operation_type = array(0 => 'Внутренний перевод', 1 => 'Услуги магазина', 2 => 'FROM API');
    var $work_type      = array(0 => 'Тестовый', 1 => 'Рабочий');
    var $comission_type = array(0 => 'Магазин', 1 => 'Покупатель', 2=> 'Пополам');
    
    public function success($text){
        return '<div class="alert alert-success">'.$text.'</div>';
    }
    
    public function fail($text){
        return '<div class="alert alert-danger">'.$text.'</div>';
    }
    
    public function secure($var, $salt='vesper', $alg='sha256'){
        return hash($alg, ($var.$salt));
    }
    
    public function sel($var1, $var2, $return1, $return2=null){
        if($return2 == null){
            if($var1 == $var2) return $return1;
        }else{
            if($var1 == $var2) return $return1;
            else return $return2;
        }
    }

    public function money($amount, $fraction=2){
        $amount = str_replace(',', '.', $amount);
        return number_format((double)$amount, $fraction, '.', '' );
    }
    
    public function header($text){
        global $core;
        $core->header = $text;
    }
    
    public function clean($var){
        $replace = array('"' => '', "'" => '');
        
        return @htmlspecialchars(str_replace(array_keys($replace), array_values($replace), trim($var)));
        unset($var, $replace);
    }
    
    function url($url){
        $replace = array('http://' => 'http://', 'www.' => 'www.', 'https://' => 'https://');
        
        return str_replace(array_keys($replace), array_values($replace), strtolower(trim($url)));
        unset($url, $replace);
    }
        
    public function start(){
        global $mysql,$user, $settings;
        @session_start();
        define('URL', 'wmrush.esy.es');
        define('IP', $this->ip());
                
        try{
            $mysql = new PDO('mysql:host=localhost;dbname=u639243856_test', 'u639243856_test', 'artemzxc');  
            $mysql->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        }catch(PDOException $e){
            echo "Ошибка MysqSQL, описание: ".$e->getMessage();
        }
        
        $query = $mysql->query("SELECT `title`, `places`, `pay`, `last_pay`, `last_pay_time`, `last_update`, `email`, `email_name`   FROM `settings`");
        $query->setFetchMode(PDO::FETCH_ASSOC);
        $settings = $query->fetch();
                
        if($settings['last_update'] < time()){
            $query = $mysql->query("SELECT `1`, `2`, `3`, `4` FROM (SELECT count(`id`) AS `1` FROM `places` WHERE `moderated` = '1')a CROSS JOIN (SELECT count(`id`) AS `2` FROM `transfer`)b CROSS JOIN (SELECT `amount` AS `3`, `date` AS `4` FROM `transfer` ORDER BY `id` DESC LIMIT 1)c");
            $query->setFetchMode(PDO::FETCH_NUM);
            list($places, $pay, $last_pay, $last_pay_time) = $query->fetch();
            
            $settings['places']        = $places;
            $settings['pay']           = $pay;
            $settings['last_pay']      = $last_pay;
            $settings['last_pay_time'] = $last_pay_time;
            $last_update               = (time()+(10*60));
            
            $mysql->query("UPDATE `settings` SET `places` = '$places', `pay` = '$pay', `last_pay` = '$last_pay', `last_pay_time` = '$last_pay_time', `last_update` = '$last_update'");
        }
        
        $settings['last_pay_var'] = $settings['last_pay'].' руб.';
        $tmp_time                 = (time() - $settings['last_pay_time']);
        
        if($tmp_time > 86400){
            $tmp_time = intval($tmp_time/86400);
            $settings['last_pay_var'] = $tmp_time.' дн. назад '.$settings['last_pay_var'];
        }elseif($tmp_time > 3600){
            $tmp_time = intval($tmp_time/3600); 
            $settings['last_pay_var'] = $tmp_time.' ч. назад '.$settings['last_pay_var'];
        }elseif($tmp_time > 60){
            $tmp_time = intval($tmp_time/60);
            $settings['last_pay_var'] = $tmp_time.' мин. назад '.$settings['last_pay_var'];
			
        }else{
            $settings['last_pay_var'] = $tmp_time.' сек. назад '.$settings['last_pay_var'];
        }
		
		if(isset($_GET['partner'])) {
			$ref = intval($_GET['partner']);
			setcookie("refID", $ref, time() + 2592000, "/");
			echo $_COOKIE['refID'];
		}
		
        
        if(!defined('ONLYCORE')){
            if(isset($_SESSION['logined'])){
                $user_id = $_SESSION['user_id'];

                if($user_id > 0){
                    $query = $mysql->query("SELECT `salt`,`code`,`login`,`email`,`money`,`moneyusd`,`regdate`, `ban`, `admin` FROM `members` WHERE `id` = '$user_id'");
                    $query->setFetchMode(PDO::FETCH_ASSOC);
                    $user = $query->fetch();

                    if(strlen($user['login']) < 3){
                        unset($_SESSION['user_id'], $_SESSION['logined']);
                        define('LOGINED', 0);
                    }else{
                        define('LOGINED', 1);
                        define('ID',      $user_id);
                        define('LOGIN',   $user['login']);
                        define('EMAIL',   $user['email']);
                        define('MONEY',   $user['money']);
                        define('MONEYUSD',   $user['moneyusd']);
						define('PURSE',   $this->purse(ID));
                        define('ADMIN',   $user['admin']);
						if($user_id != 0) {
						 define('LOG',   $user_id);
						}
                    }
                }
            }else{
                define('LOGINED', 0);
            }
        
            if(isset($_GET['sec'])){
                define('SECTION', $this->clean($_GET['sec']));
            }

            $this->render($this->module());
        }
    }
    
    public function getpage(){
        
        if(isset($_GET['page'])){
            $getpage = $this->clean($_GET['page']);
        }
        
        if(strlen($getpage) == 0){
            !defined('MERCHANT') ? $getpage = 'index' : $getpage = 'merchant';
        }
        
        return $getpage;
    }
    
    public function module(){
        if(defined('ADMINKA')){
            if(ADMIN == 1){
                $module = PATH.'/admin_pages/'.$this->getpage().'.php';
            }else{
                $module = PATH.'/pages/404.php';
            }
        }elseif(defined('PAY')){
            $module = PATH.'/pages/pay.php';
        }else{
            $module = PATH.'/pages/'.$this->getpage().'.php';
        }
        file_exists($module) ? require_once $module : require_once PATH.'/pages/404.php';
            
        ob_start();
            $page  = new module();
            $ob    = ob_get_contents();
        ob_clean();
        
        return $ob;
    }
    private function render($content){
        global $settings;
        require_once PATH.'/class/menu.php';
        require_once PATH.'/class/Twig/Autoloader.php';
        Twig_Autoloader::register();
        $menu     = new menu();
        $loader   = new Twig_Loader_Filesystem(PATH.'/theme/tpl/');
        $twig     = new Twig_Environment($loader, array('cache' => PATH.'/cache', 'debug' => true, 'auto_reload' => true, 'autoescape' => false));
        
        if(defined('MERCHANT')){
            $template = $twig->loadTemplate('merchant.tpl');
		}elseif(defined('ADMINKA')) {
		
		$template = $twig->loadTemplate('admin.tpl');
		}elseif($_GET['page'] == 'account') {
			$template = $twig->loadTemplate('account.tpl');
		}elseif($_GET['page'] == 'auth' or $_GET['page'] == 'logout') {
			$template = $twig->loadTemplate('auth.tpl');
		}elseif($_GET['page'] == 'reg') {
			$template = $twig->loadTemplate('auth.tpl');
		}elseif($_GET['page'] == 'content' or $_GET['page'] == 'support' or $_GET['page'] == 'news') {
		$template = $twig->loadTemplate('content.tpl');
		
		}elseif($_GET['page'] == 'paycheck') {
		$template = $twig->loadTemplate('merchant.tpl');
		}elseif($_GET['page'] == '404') {
		$template = $twig->loadTemplate('404.tpl');
		
		}else{
            $template = $twig->loadTemplate('template.tpl');
        }
       // $xml        = simplexml_load_file('http://www.cbr.ru/scripts/XML_daily.asp');
	//	$usd_money = $this->money($this->money(MONEY) / $this->money ($xml->Valute[9]->Value));
        
        echo $template->render(array(
            'title'     => $settings['title'],
            'header'    => $this->header,
            'menu_top'  => $menu->top(),
            'menu_auth' => $menu->auth(),
            'content'   => $content,
            'sidebar'   => $show_sidebar,
            'url'       => URL,
            
            'places'    => $settings['places'],
            'pay'       => $settings['pay'],
            'last_pay'  => $settings['last_pay_var'],
			'purse' => $this->purse(ID), 
			'money' => $this->money(MONEY), 
			'login' => LOGIN,
			'moneyusd' => $this->money(MONEYUSD),
			'log' => LOG,
			
        ));
    }
    
    public function noaccess(){
        $text = '<h4>Ошибка нет доступа</h4>';
        if(LOGINED == 1){
            $text.= $this->fail('Данная страница только для гостей');
			Header("Refresh: 1, /account");
        }else{
            $text.= $this->fail('<p>Данная страница только для авторизованных пользователей.</p>Вам необходимо авторизоваться или <a href="/reg/">завести аккаунт</a>').$this->authform();
        }

        echo $text;
    }
    
    public function redir($url, $delay=2, $full=0){
        if($full == 0){
            $seturl = ''.$url.'/';
        }else{
            $seturl = '/'.$url;
        }
            return '
            <script type="text/javascript">setTimeout("location.replace(\'/'.$seturl.'\')", (1000*'.$delay.'));</script>
            <meta http-equiv="refresh" content="'.($delay+1).'; url=http://vilpay.ff-money.ru/'.$url.'">
            <a href="http://vilpay.ff-money.ru/'.$url.'">Перенаправление, нажмите сюда, чтобы перейти моментально</a>';
    }
    
    private function ip(){
        if(!empty($_SERVER['HTTP_CLIENT_IP'])){
            $ip = $this->clean($_SERVER['HTTP_CLIENT_IP']);
        }elseif(!empty($_SERVER['HTTP_X_FORWARDED_FOR'])){
            $ip = $this->clean($_SERVER['HTTP_X_FORWARDED_FOR']);
        }else{
            $ip = $this->clean($_SERVER['REMOTE_ADDR']);
        }
        return $ip;
        unset($ip);
    }
    
    public function purse($id){
        $count  = strlen($id);
        $i      = (10-$count);
        $return = 'V';
        
        while($i > 0){
            $i--;
            $return.=0;
        }
        
        return $return.$id;
    }
    
    public function purse2id($purse){
        $numbers = str_replace('v', '', strtolower($purse));
        
        
        return intval($numbers);
    }
    
    public function authform($login=null, $return=null){
        if(isset($_GET['merchant'])){
            $add = '?merchant='.(int)$_GET['merchant'];
        }
        return '
        
		
		
		 <form action="/auth/'.$add.'" role="form" method="POST">
              <h3 class="form-title form-title-first"><i class="icon-lock"></i> Авторизация</h3>
              <div class="form-group">
                <label>Username</label>
                <input type="text" class="form-control" id="login" name="login" placeholder="Логин" value="'.$login.'">
              </div>
              <div class="form-group">
                <label>Password</label>
                <input type="password" class="form-control" id="pass" name="pass" placeholder="Пароль">
              </div>
              
              <button type="submit" class="btn btn-primary btn-lg">Вход</button>
              <a href="/" class="btn btn-link">Отмена</a>
            </form>
		
		
		
		';
    }
    
    public function sendmail($to, $theme, $msg){
        global $settings;
        $mailheaders = "Content-type: text/html; charset=utf-8\r\n"; 
        $mailheaders.= "From: ".$settings['email_name']." <".$settings['email'].">\r\n"; 
        $mailheaders.= "Reply-To: ".$settings['email']."\r\n"; 

        mail($to, $theme, $msg, $mailheaders);
    }
}
