<?php

class module extends core{
    public function __construct(){
        $this->header('Авторизация');
        
        if(LOGINED == 0){
            if(isset($_POST['login'])){
                $login  = $this->clean($_POST['login']);;
                $pass   = $this->clean($_POST['pass']);
                $err    = 0;
                $errmsg = array();

                if(!preg_match("|^[-a-z0-9_]{4,15}+$|i", $login)){
                    $err++;
                    $errmsg[$err] = 'Неверно указан логин';
                }

                if(strlen($pass) < 6){
                    $err++;
                    $errmsg[$err] = 'Слишком короткий пароль.';
                }

                if($err == 0){
                    global $mysql;
                    $query = $mysql->prepare("SELECT `id`,`pass`,`salt` FROM `members` WHERE `login` = ?");
					$query->execute(array($login));
                    $query->setFetchMode(PDO::FETCH_NUM);
                    list($uid, $uhash, $usalt) = $query->fetch();

                    if($uid < 1){
                        $err++;
                        $errmsg[$err] = "Пользователь с логином: <b>$login</b> у нас не зарегистрирован";
                    }else{
                        $gen_hash = $this->secure($pass, $usalt);

                        if($uhash != $gen_hash){
                            $err++;
                            $errmsg[$err] = "Указан неверный пароль";
                            $query        = $mysql->prepare("INSERT INTO `security` (`user`, `type`, `ip`, `date`) values (?, ?, ?, ?)");  
                            $data         = array($uid, 2, IP, time());
                            $query->execute($data);
                        }
                    }
                }

                if($err == 0){
                    if(isset($_GET['merchant'])){
                        $redir = 'account/transfer/?merchant='.(int)$_GET['merchant'];
                    }else{
                        $redir = 'account';
                    }
                    $_SESSION['logined'] = 1;
                    $_SESSION['user_id'] = $uid;
                    $text                = '<h4>Вы успешно вошли в свой аккаунт</h4><p>Сейчас вы будете перемещенны в свой аккаунт</p>'.$this->redir($redir);
                    $query               = $mysql->prepare("INSERT INTO `security` (`user`, `type`, `ip`, `date`) values (?, ?, ?, ?)");  
                    $data                = array($uid, 1, IP, time());
                    $query->execute($data);
                    
                    echo $this->success($text);
                }else{
                    foreach ($errmsg as $key => $value) {
                        $tmp.='<p><b>'.$key.'.</b> '.$value.'</p>';
                    }
                    $text = '<h4>Ошибка авторизации</h4>'.$tmp;
                    echo $this->fail($text).$this->authform($login);
                }
            }else{
                echo $this->authform();
            }
        }else{
            $this->noaccess();
        }
    }
}
