<?php

class module2 extends core{
    public function __construct(){
        global $mysql, $user;
        $this->header('Настройки аккаунта');
        
        if(LOGINED == 1){
            if(isset($_POST['pincode1'])){
                $pin_post = $_POST['pincode1'];
                $pass     = $this->clean($_POST['pass_new']);
                $pass_re  = $this->clean($_POST['pass_re']);
                $err      = 0;
                $errmsg   = array();
                
                if($pin_post != $user['code']){
                    $err++;
                    $errmsg[$err] = 'Введен неверный пинкод';
                }
                
                if(strlen($pass) < 6){
                    $err++;
                    $errmsg[$err] = 'Слишком короткий пароль.';
                }

                if(is_numeric($pass)){
                    $err++;
                    $errmsg[$err] = 'Пароль не может состоять только из цифр';
                }

                if($pass == LOGIN || $pass == $user['email']){
                    $err++;
                    $errmsg[$err] = 'Пароль должен отличаться от вашего логина или email';
                }

                if($pass != $pass_re){
                    $err++;
                    $errmsg[$err] = 'Введенные пароли не совпадают';
                }
                
                if($err == 0){
                    $text  = '<h4>Пароль изменен успешно</h4><p>Пароль изменен успешно</p><p>Теперь вам необходимо заново авторизоваться</p>';
                    $w = $mysql->prepare("UPDATE `members` SET `pass` = ? WHERE `id` = ?");  
					$w->execute(array($this->secure($pass, $user['salt']), ID));
                    echo $this->success($text.$this->redir('auth'));
                    unset($_SESSION['logined'], $_SESSION['user_id']);
                }else{
                    foreach ($errmsg as $key => $value) {
                        $tmp.='<p><b>'.$key.'.</b> '.$value.'</p>';
                    }
                    $text = '<h4>Ошибка смены пароля</h4>'.$tmp;
                    echo $this->fail($text);
                }
            }
            
            if(isset($_POST['pincode2'])){
                $pin_post = $_POST['pincode2'];
                $email     = $this->clean($_POST['email']);
                $err      = 0;
                $errmsg   = array();

                if($pin_post != $user['code']){
                    $err++;
                    $errmsg[$err] = 'Введен неверный пинкод';
                }
                
                if($email == $user['email']){
                    $err++;
                    $errmsg[$err] = 'Новый Email должен отличаться от старого';
                }

                if(!preg_match("/^[-0-9a-z_\.]+@[-0-9a-z^\.]+\.[a-z]{2,6}$/i", $email)){
                    $err++;
                    $errmsg[$err] = 'Неверно указан email';
                }
                
                if($err == 0){
                    $e = $query = $mysql->prepare("SELECT count(`id`) FROM `members` WHERE `email` = ?");
					$e->execute(array($email));
                    $query->setFetchMode(PDO::FETCH_NUM);
                    list($e1) = $query->fetch();

                    if($e1 != 0){
                        $err++;
                        $errmsg[$err] = 'Email уже используется'; 
                    }
                }
                
                if($err == 0){
                    $text  = '<h4>Email изменен</h4><p>Email изменен успешно</p>';
                    $r = $mysql->prepare("UPDATE `members` SET `email` = ? WHERE `id` = ?");
					$r->execute(array($email, ID));					
                    echo $this->success($text);
                }else{
                    foreach ($errmsg as $key => $value) {
                        $tmp.='<p><b>'.$key.'.</b> '.$value.'</p>';
                    }
                    $text = '<h4>Ошибка смены Еmail</h4>'.$tmp;
                    echo $this->fail($text);
                }
            }
            
            if(isset($_POST['pincode3'])){
			$query = $mysql->query("SELECT `email` FROM `members` WHERE id = '".ID."'");
			$query->setFetchMode(PDO::FETCH_NUM);
            list($email) = $query->fetch();
			$code  = rand(1,9).rand(0,9).rand(0,9).rand(0,9);
			$mysql->query("UPDATE `members` SET `code` = '$code' WHERE `id` = '".ID."'"); 
			$theme = 'Востановление Пин-кода: '.$settings['title'];
            $msg   = 'Вы запросили востановление пин-кода на сервисе: '.$settings['title'].'<br>
                              <h4>Новый ПИН-код</h4>
                              Ваш пин-код: <b>'.$code.'</b><br><br><div style="background: #ffa3a3; color: #f0ff01; padding: 5px;">Сохраните содержание данного письма в надежное место и удалите из почты.<br>Никому не сообщайте свои данные.<br>Все пароли у нас хранятся в зашифрованном виде</div>';
                   
            $this->sendmail($email, $theme, $msg);
			$text = '<h4>Новый пинкод выслан</h4><p>Проверьте ваш Email, на него выслан новый пинкод</p>';
			echo $this->success($text);
            }
            
            echo '
            <h4>Смена пароля</h4>
            <form class="form-horizontal" role="form" action="" method="POST">
                <div class="form-group">
                    <label for="pass_new" class="col-sm-2 control-label">Новый пароль</label>
                    <div class="col-sm-4">
                        <input type="password" class="form-control" id="pass_new" name="pass_new" placeholder="Придумайте новый пароль" autocomplete="off">
                    </div>
                </div>
                <div class="form-group">
                    <label for="pass_re" class="col-sm-2 control-label">Повторите пароль</label>
                    <div class="col-sm-4">
                        <input type="password" class="form-control" id="pass_re" name="pass_re" placeholder="Повторите новый пароль" autocomplete="off">
                    </div>
                </div>
                <div class="form-group">
                    <label for="pincode1" class="col-sm-2 control-label">Ваш пинкод</label>
                    <div class="col-sm-1">
                        <input type="text" class="form-control pincode" id="pincode1" name="pincode1" maxlength="4">
                    </div>
                </div>
                <div class="form-group">
                    <div class="col-sm-offset-2 col-sm-4">
                        <button type="submit" class="btn btn-success">Изменить пароль</button>
                    </div>
                </div>
            </form>
            
            <h4>Смена email</h4>
            <form class="form-horizontal" role="form" action="" method="POST">
                <div class="form-group">
                    <label for="email" class="col-sm-2 control-label">Ваш email</label>
                    <div class="col-sm-4">
                        <input type="email" class="form-control" id="email" name="email" placeholder="Ваш новый email" autocomplete="off" value="'.$user['email'].'">
                    </div>
                </div>
                <div class="form-group">
                    <label for="pincode2" class="col-sm-2 control-label">Ваш пинкод</label>
                    <div class="col-sm-1">
                        <input type="text" class="form-control pincode" id="pincode2" name="pincode2" maxlength="4">
                    </div>
                </div>
                <div class="form-group">
                    <div class="col-sm-offset-2 col-sm-4">
                        <button type="submit" class="btn btn-success">Изменить email</button>
                    </div>
                </div>
            </form>
            
            
            <h4>Восстановление пинкода</h4>
            <div class="alert alert-info"><p>Если вы забыли свой пин-код, можете сгенерировать новый</p>Новый пин-код будет отправлен на ваш Email</div>
            <form class="form-horizontal" role="form" action="" method="POST">
                <div class="form-group">
                    <div class="col-sm-offset-2 col-sm-4">
                        <button type="submit" class="btn btn-success" name="pincode3">Восстановить пинкод</button>
                    </div>
                </div>
            </form>
            ';
        }else{
            $this->noaccess();
        }
    }
}