<?php

class module extends core{
    public function __construct(){
        $this->header('Регистрация нового пользователя');
        
        if(LOGINED == 0){
            if(isset($_POST['login'])){
                $login  = $this->clean($_POST['login']);
                $email  = $this->clean($_POST['email']);
                $pass   = $this->clean($_POST['pass']);
                $passre = $this->clean($_POST['passre']);
                $rules  = $this->clean($_POST['rules']);
                $err    = 0;
                $errmsg = array();

                if(strlen($rules) ==  '0'){
                    $err++;
                    $errmsg[$err] = 'Необходимо согласиться с правилами';
                }

                if(!preg_match("|^[-a-z0-9_]{4,15}+$|i", $login)){
                    $err++;
                    $errmsg[$err] = 'Неверно указан логин';
                }

                if(!preg_match("/^[-0-9a-z_\.]+@[-0-9a-z^\.]+\.[a-z]{2,6}$/i", $email)){
                    $err++;
                    $errmsg[$err] = 'Неверно указан email';
                }

                if(strlen($pass) < 6){
                    $err++;
                    $errmsg[$err] = 'Слишком короткий пароль.';
                }

                if(is_numeric($pass)){
                    $err++;
                    $errmsg[$err] = 'Пароль не может состоять только из цифр';
                }

                if($pass == $login || $pass == $email){
                    $err++;
                    $errmsg[$err] = 'Пароль должен отличаться от вашего логина или email';
                }

                if($pass != $passre){
                    $err++;
                    $errmsg[$err] = 'Введенные пароли не совпадают';
                }

                if($err == 0){
                    global $mysql,$settings;
                    $query = $mysql->prepare("SELECT `e1`, `e2` FROM (SELECT count(`id`) AS `e1` FROM `members` WHERE `login` = ?)a CROSS JOIN (SELECT count(`id`) AS `e2` FROM `members` WHERE `email` = ?)b");
					$query->execute(array($login, $email));
                    $query->setFetchMode(PDO::FETCH_NUM);
                    list($e1, $e2) = $query->fetch();

                    if($e1 != 0){
                        $err++;
                        $errmsg[$err] = 'Логин: <b>'.$login.'</b>, занят'; 
                    }

                    if($e2 != 0){
                        $err++;
                        $errmsg[$err] = 'Email: <b>'.$email.'</b>, занят'; 
                    }
                }

                if($err == 0){
                    $text  = '<h4>Регистарция завершена успешно</h4>Вы успешно зарегистрировались, на указанный вами Email высланы данные о вашем аккаунте.';
                    $salt  = substr($this->secure(rand(0,999), rand(0,999)), 0,6);
                    $code  = rand(1,9).rand(0,9).rand(0,9).rand(0,9);
                    $query = $mysql->prepare("INSERT INTO `members` (`pass`, `salt`, `code`, `login`, `email`, `regdate`) values (?, ?, ?, ?, ?, ?)");  
                    $data  = array($this->secure($pass, $salt), $salt, $code, $login, $email, time());
                    $query->execute($data);
                    
                    $theme = 'Регистрация на: '.$settings['title'];
                    
                    $msg   = 'Вы успешно зарегистрирвоались на: '.$settings['title'].'<br>
                              <h4>Данные для входа</h4>Логин: <b>'.$login.'</b><br>
                              Ваш пароль: <b>'.$pass.'</b><br>
                              Ваш пин-код: <b>'.$code.'</b><br><br><div style="background: #ffa3a3; color: #f0ff01; padding: 5px;">Сохраните содержание данного письма в надежное место и удалите из почты.<br>Никому не сообщайте свои данные.<br>Все пароли у нас хранятся в зашифрованном виде</div>';
                    
                    $this->sendmail($email, $theme, $msg);
                    
                    echo $this->success($text);
					header("Refresh: 3, /auth");
                }else{
                    foreach ($errmsg as $key => $value) {
                        $tmp.='<p><b>'.$key.'.</b> '.$value.'</p>';
                    }
                    $text = '<h4>Ошибка регистрации</h4>'.$tmp;
                    echo $this->fail($text).$this->form($login, $email);
                }
            }else{
                echo $this->form();
            }
        }else{
            $this->noaccess();
        }
    }

    private function form($login=null, $email=null){
        return '
		
		 <form action="" role="form" method="POST">
              <h3 class="form-title form-title-first"><i class="icon-lock"></i> Регистрация</h3>
              <div class="form-group">
                <label>Лоигн</label>
                <input type="text" class="form-control" id="login" name="login" placeholder="Логин" value="'.$login.'">
              </div>
			  
			  <div class="form-group">
                <label>E-Mail</label>
                <input type="email" class="form-control" id="email" name="email" placeholder="E-Mail" value="'.$email.'">
              </div>
			  
			  
              <div class="form-group">
                <label>Пароль</label>
                <input type="password" class="form-control" id="pass" name="pass" placeholder="Пароль">
              </div>
			  
			  <div class="form-group">
                <label>Повтор пароля</label>
                <input type="password" class="form-control" id="passre" name="passre" placeholder="Повтор пароля">
              </div>
			  
			  <div class="form-group">
                <label></label>
               <input type="checkbox" name="rules"> С <a href="#">Правилами</a> согласен
              </div>
              
              <button type="submit" class="btn btn-primary btn-lg">Регистрация</button>
              <a href="/" class="btn btn-link">Отмена</a>
            </form>
		
		
		
        ';
    }
}